#ifndef SM_GENERAL_WRAPPER_HEADER_H
#define SM_GENERAL_WRAPPER_HEADER_H
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "SM_PubDataWrapper.h"
#include "SM_SubDataWrapper.h"
#include "dpc_sm/executable.h"

using namespace jac::ap::smservice::skeleton;
using namespace jac::ap::dmservice::proxy;
using namespace jac::ap::emservice::proxy;
using namespace jac::ap::vedservice::proxy;
using namespace jac::ap::canservice::proxy;

GENERATE_PUB_WRAPPER(SM2Decision_Provide, SM2Decision_PubDataWrapper, SMServiceSkeleton, dpc::SM4Decision, SM4DecisionEvent);

GENERATE_SUB_WRAPPER(DM2SM_Required, DM2SM_SubDataWrapper, DMServiceProxy, dpc::Decision4SM, Decision4SMEvent, "4", 10);
GENERATE_SUB_WRAPPER(VED2SM_Required,VED2SM_SubDataWrapper, VEDServiceProxy, dpc::VED4DPC, VED4DPCEvent, "11", 10);
GENERATE_SUB_WRAPPER(DM2SMObjectTrim_Required, DM2SMObjectTrim_SubDataWrapper, DMServiceProxy, dpc::ObjectTrim, ObjectTrimEvent, "4", 10);
GENERATE_SUB_WRAPPER(EM2SMLaneInfo_Required, EM2SMLaneInfo_SubDataWrapper, EMServiceProxy, dpc::LaneInfo, LaneInfoEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2SMLeftLine_Required, EM2SMLeftLine_SubDataWrapper, EMServiceProxy, dpc::LeftLine, LeftLineEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2SMLeftRoadEdge_Required, EM2SMLeftRoadEdge_SubDataWrapper, EMServiceProxy, dpc::LeftRoadEdge, LeftRoadEdgeEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2SMODDInfo_Required, EM2SMODDInfo_SubDataWrapper, EMServiceProxy, dpc::ODDInfo, ODDInfoEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2SMRMEgoLftLnegeometry_Required, EM2SMRMEgoLftLnegeometry_SubDataWrapper, EMServiceProxy, dpc::RMEgoLftLnegeometry, RMEgoLftLnegeometryEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2SMRMEgoRgtLnegeometry_Required, EM2SMRMEgoRgtLnegeometry_SubDataWrapper, EMServiceProxy, dpc::RMEgoRgtLnegeometry, RMEgoRgtLnegeometryEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2SMRMRdEdgeLftgeometry_Required, EM2SMRMRdEdgeLftgeometry_SubDataWrapper, EMServiceProxy, dpc::RMRdEdgeLftgeometry, RMRdEdgeLftgeometryEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2SMRMRdEdgeRgtgeometry_Required, EM2SMRMRdEdgeRgtgeometry_SubDataWrapper, EMServiceProxy, dpc::RMRdEdgeRgtgeometry, RMRdEdgeRgtgeometryEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2SMRMSMMessage_Required, EM2SMRMSMMessage_SubDataWrapper, EMServiceProxy, dpc::RMSMMessage, RMSMMessageEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2SMRightLine_Required, EM2SMRightLine_SubDataWrapper, EMServiceProxy, dpc::RightLine, RightLineEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2SMRightRoadEdge_Required, EM2SMRightRoadEdge_SubDataWrapper, EMServiceProxy, dpc::RightRoadEdge, RightRoadEdgeEvent, "6", 10);
GENERATE_SUB_WRAPPER(CAN2SM_Required, CAN2SM_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "3", 10);


class GeneralWrapper {
public:
    SM2Decision_Provide _SM2Decision_Provide;
    DM2SM_Required _DM2SM_Required;
    VED2SM_Required _VED2SM_Required;
    DM2SMObjectTrim_Required _DM2SMObjectTrim_Required;
    EM2SMLaneInfo_Required _EM2SMLaneInfo_Required;
    EM2SMLeftLine_Required _EM2SMLeftLine_Required;
    EM2SMLeftRoadEdge_Required _EM2SMLeftRoadEdge_Required;
    EM2SMODDInfo_Required _ODDInfo_Required;
    EM2SMRMEgoLftLnegeometry_Required _EM2SMRMEgoLftLnegeometry_Required;
    EM2SMRMEgoRgtLnegeometry_Required _EM2SMRMEgoRgtLnegeometry_Required;
    EM2SMRMRdEdgeLftgeometry_Required _EM2SMRMRdEdgeLftgeometry_Required;
    EM2SMRMRdEdgeRgtgeometry_Required _EM2SMRMRdEdgeRgtgeometry_Required;
    EM2SMRMSMMessage_Required _EM2SMRMSMMessage_Required;
    EM2SMRightLine_Required _EM2SMRightLine_Required;
    EM2SMRightRoadEdge_Required _EM2SMRightRoadEdge_Required;
    CAN2SM_Required _CAN2SM_Required;
    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
};


#endif
